import javax.swing.*;
import java.awt.event.*;

/**
 * Exemple de MVC simple
 * 
 * @author F. Mallet 
 * @version 2004.08.24
 */
public class Exemple implements ActionListener
{
    private Compteur modele = new Compteur(0);
    private JButton tB = new JButton("Texte");
    private JButton gB = new JButton("Graphique");
    
    private Exemple()
    {
        JFrame frame = new JFrame("Exemple MVC");
        frame.getContentPane().add(tB, "North");
        frame.getContentPane().add(gB, "South");
        
        tB.addActionListener(this);
        gB.addActionListener(this);
        frame.setBounds(0,100,200,90);
        frame.setVisible(true);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    static int num = 1;
    void showInFrame(IVue vue){
        JFrame frame = new JFrame("Vue "+num);
        CompteurControle controleur = new CompteurControle(modele, vue);
        frame.getContentPane().add(controleur, "Center");
        JButton incB = new JButton("incrementer");
        frame.getContentPane().add(incB, "South");
      
        // enregistre le nouveau contrleur auprs du modle
        modele.addCompteurListener(controleur);
        
        incB.addActionListener(this);
        frame.setBounds(200*num,100,200,100);
        frame.setVisible(true);
        num++;
    }
    
    public void actionPerformed(ActionEvent ae) 
    {
        Object src = ae.getSource();
        if (src == tB) showInFrame(new VueTexte());
        else if (src == gB) showInFrame(new VueGraph());
        else 
            modele.incrementer();
    }
    
    static public void demo() {
        new Exemple();
    }
}
